/* Problem URL: https://codeforces.com/contest/954/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, s, t;
    cin >> n >> m >> s >> t;
    s--, t--;

    vvi graph(n);
    vvi adj(n, vi(n));

    while (m--) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        graph[a].push_back(b);
        graph[b].push_back(a);
        adj[a][b] = 1;
        adj[b][a] = 1;
    }

    int oo = INT32_MAX >> 1;

    auto bfs = [&](int s, vi &depth){
        depth[s] = 0;
        queue<int> q;
        q.push(s);

        while (!q.empty()) {
            auto i = q.front();
            q.pop();

            for (auto j : graph[i]) {
                if (depth[j] > depth[i] + 1) {
                    depth[j] = depth[i] + 1;
                    q.push(j);
                }
            }
        }
    };

    vi depth1(n, oo);
    vi depth2(n, oo);
    
    bfs(s, depth1);
    bfs(t, depth2);

    int minimal = depth1[t];

    V<bool> ispath(n);

    ll ans = 0;
    rep(i, n) {
        nrep(j, i + 1, n) {
            if (adj[i][j]) {
                continue;
            }

            auto check = [&](int u, int v) {
                int ne1 = min(depth1[u], depth1[v] + 1);
                int ne2 = min(depth2[u], depth2[v] + 1);

                return ne1 + ne2 >= minimal;
            };

            if (check(i, j) && check(j, i)) {
                ans++;
            }
        }
    }

    cout << ans << '\n';
}
